Trap command not working


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Trap command not working
# 1  
Old 12-16-2016
Trap command not working

Hi Folks -

For some reason, my trap command is not working. It's placed just prior to a normal exit:

Code:
#:: ------------------------------------------------------------------------
#::-- Script Name: LCM_Backup.sh
#::  
#::-- Description: This script leverages Utility.sh to perform LCM Backups
#:: 
#::-- Parameters:  Call properties file to get environment variables to determine 
#::                login info, database, application, etc.
#::        
#::-- Author:       Joe Shmoe
#::-- Date:           12/16/16
#:: ------------------------------------------------------------------------
#source /u01/Hyperion_Batch/Scripts/Batch/_env.sh

#::-- Set Script Action --::#

_ACTION=Export

#::-- Set Script Name --::#
#::-- ${_SN%%.sh*} --::

_SN=${0##*/}

#::-- Set Path Variables --::

cd $HOME

_MAINPATH=$(pwd)/Hyperion_Batch/
_LOGPATH=Logs/
_ERRORPATH=Errors/

#::-- Set Log & Error subdirectories pertaining to the specific process --::#

_PLOGPATH=LCM_Logs/
_PERRORPATH=LCM_Errors/

#::-- Set Date and Time Variable --::#
_DAY=$(date +%d)
_MONTH=$(date +%m)
_YEAR=$(date +%Y)
_DATESTAMP=${_YEAR}${_MONTH}${_DAY}
_HOUR=$(date +%H)
_MINUTE=$(date +%M)
_SECOND=$(date +%S)
_TIME=${_HOUR}${_MINUTE}
_DATETIMESTAMP=${_DATESTAMP}_${_TIME}

#::-- Establish STDOUT and STDERROR repositories --::
_ARC_LP=${_MAINPATH}${_LOGPATH}${_PLOGPATH}${_YEAR}_${_MONTH}${_DAY}
_ARC_EP=${_MAINPATH}${_ERRORPATH}${_PERRORPATH}${_YEAR}_${_MONTH}${_DAY}
    
mkdir -p ${_ARC_LP}
mkdir -p ${_ARC_EP}

#::-- Prepare File Name Format --::#
_HOST=$(hostname -f)
_FN=${_SN%%.sh*}_${_HOST}_${_TIME}

#::-- Establish STDOUT and STDERROR files --::#
_LF=${_ARC_LP}/${_FN}.log
_EF=${_ARC_EP}/${_FN}.err

#::-- Direct STDOUT and STDERROR to repositories --::# 
exec 2>${_EF} > ${_LF}

#::-- Establish LCM Variables --::

_EPM_SYSTEM_BIN=/u01/EPM/Oracle/Middleware/user_projects/epmsystem1/bin/
_IMPORTEXPORT_DIR=/u01/EPM/Oracle/Middleware/user_projects/epmsystem1/import_export/
_LCM_DIR=AUTODEMO_FIN_PLAN_CS/
_LCM_USER=admin
_LCM_PSWD=psswrd

#:: Begin Script Processing --::#
echo ---------------------------------------------------------
echo "${_SN} beginning at ${_TIME}"                        
echo                                                                                                        
echo "Execute ${_LCM_DIR} Life Cycle Management Backup"                                         
echo ---------------------------------------------------------

sed "s/name=\"\" password=\"\"/name=\"${_LCM_USER}\" password=\"${_LCM_PSWD}\"/" ${_IMPORTEXPORT_DIR}${_LCM_DIR}${_ACTION}.xml > ${_IMPORTEXPORT_DIR}${_LCM_DIR}${_ACTION}1.xml
rm ${_IMPORTEXPORT_DIR}${_LCM_DIR}${_ACTION}.xml
mv ${_IMPORTEXPORT_DIR}${_LCM_DIR}${_ACTION}1.xml ${_IMPORTEXPORT_DIR}${_LCM_DIR}${_ACTION}.xml

#:: Begin Script Processing --::
echo ---------------------------------------------------------                                                                                                                            
echo "Execute ${_LCM_DIR} Life Cycle Management Backup"                                         
echo ---------------------------------------------------------

sh ${_EPM_SYSTEM_BIN}Utility.sh ${_IMPORTEXPORT_DIR}${_LCM_DIR}${_ACTION}.xml

if [ $? -eq 0 ]
then
  echo ---------------------------------------------------------
  echo "${_LCM_DIR} Life Cycle Management Backup Successful"                           
  echo ---------------------------------------------------------
  #::-- If empty, delete YYYY_MMDD error file subdirectory --::
  trap "[ -s ${_EF} ] || rm -f ${_EF} ] && rmdir ${_ARC_EF}" exit 0
  
else
  echo ---------------------------------------------------------
  echo "${_LCM_DIR} Life Cycle Management Backup Unsuccessful"                      
  echo ---------------------------------------------------------
  exit 1
  fi

However, in earlier threads this months, I was told to place the trap earlier in my script. When I do so, I get an error with this message :

Code:
trap: usage: trap [-lp] [arg signal_spec ...]

Thanks!
# 2  
Old 12-16-2016
Restore the 'exit 0' at the end of it back to EXIT. That part is not shell script -- it's a signal definition, and EXIT is a special value it also accepts (not technically a signal).

Place it early in your script, immediately after ${_EF} and ${_ARC_EF} are defined.
# 3  
Old 12-16-2016
A primary use of trap is for interactive scripts - example: prevent users from typing ctrl/c to stop the process, because if the process gets interrupted in a bad place you have a problem.

It can also be used as a primary single known exit point when an error occurs.

Code:
trap "do something " EXIT

is how to trap an exit.

Your trap call is not like anything above AFAICS. What EXACTLY are you trying to do? - not how you want to do it. Please.
# 4  
Old 12-16-2016
Quote:
Originally Posted by jim mcnamara
Your trap call is not like anything above AFAICS. What EXACTLY are you trying to do? - not how you want to do it. Please.
I recall that trap from a previous thread, where I wrote it. The objective is to remove the logfile and log folder on exit, if the log file is empty. It just had EXIT at the end of it at the time.

Then they went through a thread where they realized their 'exit 1's were causing nonzero exit statuses and must have edited that unrelated EXIT into 'exit 0' along with all the others to "fix" it.
# 5  
Old 12-16-2016
Okay - the lack of EXIT triggered the request. Which still does not explain using the trap command inside an if block at the bottom - you pointed out that they had a correct version earlier.
# 6  
Old 12-16-2016
Quote:
Originally Posted by jim mcnamara
Okay - the lack of EXIT triggered the request. Which still does not explain using the trap command inside an if block at the bottom - you pointed out that they had a correct version earlier.
Purely random changes to see what worked. OP knew where it really belonged and said so, but dumping it inside that block made the error go away "sometimes", i.e. whenever that block wasn't used.
# 7  
Old 12-16-2016
You were told in that thread again and again how to use the trap command, and where to get basic information about it. I'm afraid it can't be made clearer.
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

trap command

dear all; I can't under stand what does "trap" command do: for example see below: trap "echo; echo no interrupts >&2; sleep 3" 2 3 15 Plz , can any body explain the action of this command? BR (3 Replies)
Discussion started by: ahmad.diab
3 Replies

2. UNIX for Dummies Questions & Answers

trap command

I'm learning about the trap command from my bash book. I tried out the little script they gave: trap "echo 'You hit control-C!' " INT while true; do sleep 60 done But when I type control-c, the script just stops and the message is not displayed. I checked stty all and saw that control-c... (11 Replies)
Discussion started by: Straitsfan
11 Replies

3. UNIX for Advanced & Expert Users

trap command

Hello experts! I need to know the use of trap command please In one of our program we have trap "rm -f temp1 ; exit 1" 1 2 15 0 and program always exit with 1 there is a rm -f temp1 as well at the end of the program as rm -f temp1 exit 0 when I test a probram with set... (4 Replies)
Discussion started by: ramshree01
4 Replies

4. Shell Programming and Scripting

Help with getting a Ctrl-C trap working w/ a piped tail -f...

Hi All, Although each line below seems to work by itself, I've been having trouble getting the Control-C trap working when I add the "|perl -pe..." to the end of the tail -f line, below. (That |perl -pe statement basically just adds color to highlight the word "ERROR" while tailing a log... (2 Replies)
Discussion started by: chatguy
2 Replies

5. Shell Programming and Scripting

Trap not working in orphaned child processes

I've search the various posts in these forums, but have not come up with a solution to my problem. I have a parent process that calls a child script, runs it in the background and the parent finishes - without waiting for the child process to complete. Inside the child, a trap is issued to trap... (6 Replies)
Discussion started by: HobieCoop
6 Replies

6. Shell Programming and Scripting

Cntl+z Trap is not detecting ??? Help required to add a trap detection ???

Hi folks, I have tried to add some trap detection in the below script....this script is used to monitor database activities...in a rather awkward way :rolleyes:.... The idea behind adding trap is that....this script creates lots of temporary files in the running folder to store the count... (1 Reply)
Discussion started by: frozensmilz
1 Replies

7. Shell Programming and Scripting

Use of TRAP Command

Hi, I would like to know the use of TRAP command. I am very new to the UNIX environment. I have just started learning the basic. So please teach me in a very simple way to understand. Also i would like to know the use of following command: trap 'dialog --msgbox "Script Aborted1" 6 50 ;... (2 Replies)
Discussion started by: Deepakh
2 Replies

8. UNIX for Dummies Questions & Answers

trap command

Dear All could you please explain me what does the trap command do and how I can write a program which can work as a trap command(in C Language). (1 Reply)
Discussion started by: mobile01
1 Replies

9. UNIX for Dummies Questions & Answers

trap command

i have the following script that displays the current time until the user presses CTR + c.... but it does not work properly.... Something is not right with the trap command... Help plz... :confused: # script to continuously display current time. # if script is terminated trap signal... (3 Replies)
Discussion started by: onlyc
3 Replies

10. Shell Programming and Scripting

Using TRAP command

I'm using the trap command to capture any signals received whilst my script is running. How's the best way of writing the signal and any other error messages to a file/error log' without having to type '2>$1' on the command line after the script name? Cheers (3 Replies)
Discussion started by: dbrundrett
3 Replies
Login or Register to Ask a Question